/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package telecomnancy.directdealing;

import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;
import telecomnancy.directdealing.controller.AccueilController;
import telecomnancy.directdealing.controller.AjouteroffreController;
import telecomnancy.directdealing.controller.ConnexionController;
import telecomnancy.directdealing.controller.ConsulterOffreController;
import telecomnancy.directdealing.controller.InfoflorainsController;
import telecomnancy.directdealing.controller.InscriptionController;
import telecomnancy.directdealing.controller.MessagerieController;
import telecomnancy.directdealing.controller.ModifController;
import telecomnancy.directdealing.controller.ModifOffreController;
import telecomnancy.directdealing.controller.PauseCompteController;
import telecomnancy.directdealing.controller.ProfilController;
import telecomnancy.directdealing.controller.TdbController;
import telecomnancy.directdealing.controller.VoiroffresController;
import telecomnancy.directdealing.database.DatabaseManager;
import telecomnancy.directdealing.model.*;

public class App extends Application {
    private Stage primaryStage;

    public static void main(String[] args) {
        Application.launch(args);
    }

    @Override
    public void start(Stage primaryStage) {
        DatabaseManager.intialize();
        DatabaseManager.users.forEach(u->DatabaseManager.addUser(u));
        DatabaseManager.posts.forEach(p->DatabaseManager.addPost(p));
        try {
            this.primaryStage = primaryStage;
            primaryStage.setTitle("TN DirectDealing");
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/accueil.fxml"));
            Parent root = loader.load();
            AccueilController controller = loader.getController();
            controller.setApp(this);
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void accueil(){
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/accueil.fxml"));
            Parent root = loader.load();
            AccueilController controller = loader.getController();
            controller.setApp(this);
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void connexion() {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/connexion.fxml"));
            Parent root = loader.load();
            ConnexionController controller = loader.getController();
            controller.setApp(this);
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void inscription() {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/inscription.fxml"));
            Parent root = loader.load();
            InscriptionController controller = loader.getController();
            controller.setApp(this);
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void tdb(User user) {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/tableauDeBord.fxml"));
            loader.setController(new TdbController(user,this));
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void ajouteroffre(User user){
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/newoffre.fxml"));
            loader.setController(new AjouteroffreController(this, user));
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }     
    }
    public void profil(User user) {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/profil.fxml"));
            loader.setController(new ProfilController(user,this));
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void listoffres(User user) {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/listoffres.fxml"));
            loader.setController(new VoiroffresController(user,this));
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void vueoffre(User user, Post offre) {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/vueoffre.fxml"));
            loader.setController(new ConsulterOffreController(user,this, offre));
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void infoflorains(User user) {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/infoFlorains.fxml"));
            loader.setController(new InfoflorainsController(user,this));
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void messagerie(User user) {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/messagerie.fxml"));
            loader.setController(new MessagerieController(user,this));
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void modifinfo(User user) {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/modifinfo.fxml"));
            loader.setController(new ModifController(user,this));
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void modifoffre(User user,Post offre) {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/modifoffre.fxml"));
            loader.setController(new ModifOffreController(user,this,offre));
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void pausecompte(User user) {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/profilpause.fxml"));
            PauseCompteController p = new PauseCompteController(user, this);
            loader.setController(p);
            p.PauseCompte(user.getUsername());
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void restaurecompte(User user){
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("/profil.fxml"));
            PauseCompteController p = new PauseCompteController(user, this);
            loader.setController(p);
            p.RestoreCompte(user.getUsername());
            Parent root = loader.load();
            Scene scene = new Scene(root, 640, 420);
            primaryStage.setScene(scene);
            primaryStage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
