package telecomnancy.directdealing.controller;

import javafx.application.Platform;
import javafx.beans.Observable;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.DatePicker;
import javafx.scene.control.Menu;
import javafx.scene.control.MenuItem;
import javafx.scene.control.TextField;
import javafx.scene.text.Text;
import javafx.util.Duration;
import telecomnancy.directdealing.App;
import telecomnancy.directdealing.database.DatabaseManager;
import telecomnancy.directdealing.model.Post;
import telecomnancy.directdealing.model.PostType;
import telecomnancy.directdealing.model.User;
import java.time.temporal.*;

public class AjouteroffreController {
    @FXML
    MenuItem tdb;
    @FXML
    MenuItem quitter;
    @FXML
    MenuItem deco;
    @FXML
    MenuItem profil;
    @FXML
    MenuItem messagerie;
    @FXML
    MenuItem offres;
    @FXML
    MenuItem infoflo;
    @FXML
    Menu florains;
    @FXML
    Button retour;
    @FXML
    Button ajouter;
    @FXML
    TextField titre;
    @FXML
    CheckBox ponctuel;
    @FXML
    CheckBox recurrent;
    @FXML
    TextField localisation;
    @FXML
    DatePicker datedebut;
    @FXML
    DatePicker datefin;
    @FXML
    TextField description;
    @FXML
    CheckBox equipement;
    @FXML
    CheckBox service;
    @FXML
    ChoiceBox<String> categorie;
    ObservableList<String> cat=FXCollections.observableArrayList("Informatique","Scolaire","Jardinerie","Maison","Bricolage","Automobile","Bien-être","Mode","Loisirs","Autres");
    PostType type;
    private App app;
    private User user;
    String frequence;

    public AjouteroffreController(App app,User user){
        this.app=app;
        this.user=user;
    }

    public void initialize(){
        categorie.setValue("Autres");
        categorie.setItems(cat);
        deco.setOnAction(event-> this.app.accueil());
        quitter.setOnAction(event->Platform.exit());
        profil.setOnAction(event->this.app.profil(this.user));
        tdb.setOnAction(event->this.app.tdb(this.user));
        messagerie.setOnAction(event-> this.app.messagerie(this.user));
        offres.setOnAction(event->this.app.listoffres(this.user));
        florains.setText(this.user.getFlorains() +" florains");
        retour.setOnAction(event->this.app.tdb(user));
        infoflo.setOnAction(event->this.app.infoflorains(user));
        ponctuel.selectedProperty().addListener((observable, oldValue, newValue) -> {
            if (newValue) {
                recurrent.setSelected(false);
            }
        });
        recurrent.selectedProperty().addListener((observable, oldValue, newValue) -> {
            if (newValue) {
                ponctuel.setSelected(false);
            }
        });
        service.selectedProperty().addListener((observable, oldValue, newValue) -> {
            if (newValue) {
                equipement.setSelected(false);
            }
        });
        equipement.selectedProperty().addListener((observable, oldValue, newValue) -> {
            if (newValue) {
                service.setSelected(false);
            }
        });
        ajouter.setOnAction(event->this.ajouter());
    }

    public void ajouter(){
        int n= DatabaseManager.getN()+1;
        if (ponctuel.isSelected()) {
            frequence="ponctuel";
        }
        else{
            frequence="recurrent";
        }
        if (service.isSelected()) {
            type=PostType.SERVICE;
        }
        else{
            type=PostType.EQUIPMENT;
        }
        String datedeb=datedebut.getValue().toString();
        String datef=datefin.getValue().toString();
        long durée=ChronoUnit.DAYS.between(datedebut.valueProperty().getValue(), datefin.valueProperty().getValue());
        Post poste=new Post(n, user,titre.getText(),description.getText(),frequence, type, 50 , durée, datedeb, datef, true, localisation.getText(),categorie.getValue().toString());
        DatabaseManager.addPost(poste);
        this.app.tdb(user);
    }
    

}
