package telecomnancy.directdealing.controller;

import java.io.IOException;

import javafx.fxml.FXML;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.MenuItem;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import telecomnancy.directdealing.App;
import telecomnancy.directdealing.database.CredentialsCheck;
import telecomnancy.directdealing.database.DatabaseManager;
import telecomnancy.directdealing.model.User;

public class ConnexionController {
    @FXML
    private TextField username;
    @FXML
    private PasswordField password;
    @FXML
    private Button valider;
    @FXML
    private MenuItem accueil;
    private App app;

    public void setApp(App app) {
        this.app = app;
    }

    @FXML
    public void initialize() throws IOException {
        valider.setOnAction(event -> {
            this.connexion();
        });
        accueil.setOnAction(event -> this.app.accueil());
    }

    public void connexion() {
        CredentialsCheck result = DatabaseManager.checkCredentials(username.getText(), password.getText());
        if (result == CredentialsCheck.CONNECTED) {
            User user = DatabaseManager.getUserByUsername(username.getText());
            app.tdb(user);
        } else {
            Alert alert = new Alert(Alert.AlertType.ERROR);
            alert.setTitle("Erreur");
            alert.setHeaderText("Erreur de connexion");
            alert.setContentText(result.toString());
            alert.show();
        }
    }
}
