package telecomnancy.directdealing.controller;

import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import telecomnancy.directdealing.App;
import telecomnancy.directdealing.database.DatabaseManager;
import telecomnancy.directdealing.model.User;
import telecomnancy.directdealing.model.Post;
import javafx.scene.text.Text;

public class ConsulterOffreController {
    @FXML
    MenuItem tdb;
    @FXML
    MenuItem quitter;
    @FXML
    MenuItem deco;
    @FXML
    MenuItem profil;
    @FXML
    MenuItem messagerie;
    @FXML
    MenuItem offres;
    @FXML
    Menu florains;
    @FXML
    Label lvendeur;
    @FXML
    Label lprice;
    @FXML
    Label ltype;
    @FXML
    Label lstartDate;
    @FXML
    Label lendDate;
    @FXML 
    Label llocalisation;
    @FXML
    Label ldescription;
    @FXML
    Button contacter;
    @FXML
    Button annuler;
    @FXML
    Text title;
    private App app;
    private User user;
    private Post offre;

    public ConsulterOffreController(User user, App app, Post offre){
        this.user=user;
        this.app=app;
        this.offre = offre;
    }

    public void initialize(){
        deco.setOnAction(event-> this.app.accueil());
        quitter.setOnAction(event->Platform.exit());
        profil.setOnAction(event->this.app.profil(this.user));
        tdb.setOnAction(event->this.app.tdb(this.user));
        messagerie.setOnAction(event-> this.app.messagerie(this.user));
        offres.setOnAction(event->this.app.listoffres(this.user));

        title.setText(offre.getTitle());
        lvendeur.setText(offre.getOwner().getUsername());
        lprice.setText(offre.getPrice()+"");
        ltype.setText(offre.getType().toString());
        lstartDate.setText(offre.getStartDate());
        lendDate.setText(offre.getEndDate());
        llocalisation.setText(offre.getLocation());
        ldescription.setText(offre.getDescription());

        annuler.setOnAction(event->this.app.listoffres(this.user));
        florains.setText(this.user.getFlorains() +" florains");
        contacter.setOnAction(event-> {
            MessagerieController.addMessage(this.user.getUsername(), this.offre.getOwner().getUsername(), "Bonjour, je suis intéressé par l'offre "+this.offre.getTitle()+".");
            MessagerieController.addMessage(this.user.getUsername(), this.offre.getOwner().getUsername(), this.offre.getId()+" ACCEPTER");
            MessagerieController.addMessage(this.user.getUsername(), this.offre.getOwner().getUsername(), this.offre.getId()+" REFUSER");
            Alert alert = new Alert(Alert.AlertType.INFORMATION);
            alert.setTitle("Information");
            alert.setHeaderText("Message envoyé !");
            alert.setContentText("Le vendeur a été informé de votre intérêt pour son offre. Vous pourrez consulter sa réponse dans votre messagerie.");
            alert.show();
        });
    }   
}
