package telecomnancy.directdealing.controller;

import java.io.IOException;
import java.sql.SQLException;

import javafx.fxml.FXML;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.MenuItem;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import telecomnancy.directdealing.App;
import telecomnancy.directdealing.database.DatabaseManager;
import telecomnancy.directdealing.model.User;

public class InscriptionController {
    @FXML
    private TextField username;
    @FXML
    private PasswordField password;
    @FXML
    private PasswordField passwordconfirm;
    @FXML 
    private TextField mail;
    @FXML 
    private TextField phoneNumber;
    @FXML 
    private Button valider;
    @FXML
    private MenuItem accueil;
    private App app;


    public void setApp(App app){
        this.app = app;
    }
    @FXML
    public void initialize() throws IOException{
        valider.setOnAction(event-> {
            try {
                this.inscription();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        });
        accueil.setOnAction(event->this.app.accueil());
    } 

    public void inscription() throws SQLException{
        if (password.getText().equals(passwordconfirm.getText())) {
            User user = new User(username.getText(),mail.getText(),password.getText(),phoneNumber.getText());
            DatabaseManager.addUser(user);
            app.connexion();
        }
        else {
            Alert alert = new Alert(Alert.AlertType.ERROR);
            alert.setTitle("Erreur");
            alert.setHeaderText("Erreur d'inscription'");
            alert.setContentText("Les mots de passe ne correspondent pas.");
            alert.show(); 
        }
    }
}
