package telecomnancy.directdealing.controller;

import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.DatePicker;
import javafx.scene.control.Menu;
import javafx.scene.control.MenuItem;
import javafx.scene.control.TextField;
import javafx.scene.text.Text;
import telecomnancy.directdealing.App;
import telecomnancy.directdealing.database.DatabaseManager;
import telecomnancy.directdealing.model.Post;
import telecomnancy.directdealing.model.User;
import java.time.format.DateTimeFormatter;
import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.ZoneId;

public class ModifOffreController {
    @FXML
    MenuItem tdb;
    @FXML
    MenuItem quitter;
    @FXML
    MenuItem deco;
    @FXML
    MenuItem profil;
    @FXML
    MenuItem messagerie;
    @FXML
    MenuItem offres;
    @FXML
    Menu florains;
    @FXML
    MenuItem infoflo;
    @FXML
    Button retour;
    @FXML
    Button supprimer;
    @FXML
    Button modifier;
    @FXML
    TextField titre;
    @FXML
    DatePicker datedebut;
    @FXML
    DatePicker datefin;
    @FXML
    TextField localisation;
    @FXML
    TextField description;
    DateTimeFormatter formatter = DateTimeFormatter.ofPattern("dd-MM-yyyy");
    private App app;
    private User user;
    private Post offre;

    public ModifOffreController(User user,App app,Post offre){
        this.user=user;
        this.app=app;
        this.offre=offre;
    }

    public void initialize(){
        deco.setOnAction(event-> this.app.accueil());
        quitter.setOnAction(event->Platform.exit());
        profil.setOnAction(event->this.app.profil(this.user));
        tdb.setOnAction(event->this.app.tdb(this.user));
        messagerie.setOnAction(event-> this.app.messagerie(this.user));
        offres.setOnAction(event->this.app.listoffres(this.user));
        florains.setText(this.user.getFlorains() +" florains");
        infoflo.setOnAction(event-> this.app.infoflorains(this.user));

        retour.setOnAction(event->this.app.tdb(user));
        supprimer.setOnAction(event->supp());
        modifier.setOnAction(event->modif());

        titre.setText(offre.getTitle());
        description.setText(offre.getDescription());
        localisation.setText(offre.getLocation());
        
        datedebut.setValue(LocalDate.parse(offre.getStartDate()));
        datefin.setValue(LocalDate.parse(offre.getEndDate()));
    }

    public void supp(){
        DatabaseManager.deletePost(offre);
        this.app.tdb(user);
    }

    public void modif(){
        Post newoffre=offre;
        newoffre.setTitle(titre.getText());
        newoffre.setDescription(description.getText());
        newoffre.setLocation(localisation.getText());
        newoffre.setEndDate(datefin.getValue().toString());
        newoffre.setStartDate(datedebut.getValue().toString());
        //DatabaseManager.deletePost(offre);
        //DatabaseManager.addPost(newoffre);
        DatabaseManager.modif(newoffre);
        this.app.tdb(user);
    }

    public LocalDate StringDate2LocalDate(String date) {
        long timestamp = Long.parseLong(date);

        // Convertir le timestamp en Instant
        Instant instant = Instant.ofEpochMilli(timestamp);

        // Convertir l'Instant en LocalDateTime
        LocalDateTime localDateTime = LocalDateTime.ofInstant(instant, ZoneId.of("UTC"));

        // Obtenir la LocalDate à partir de LocalDateTime
        return localDateTime.toLocalDate();
    }
}   
