package telecomnancy.directdealing.controller;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.Menu;
import javafx.scene.control.MenuItem;
import telecomnancy.directdealing.App;
import telecomnancy.directdealing.database.DatabaseManager;
import telecomnancy.directdealing.model.User;
import telecomnancy.directdealing.model.Post;

public class PauseCompteController {
    @FXML
    Label username;
    @FXML
    Label email;
    @FXML 
    Label password;
    @FXML
    Label phoneNumber;
    @FXML
    MenuItem tdb;
    @FXML
    MenuItem quitter;
    @FXML
    MenuItem deco;
    @FXML
    MenuItem infoflo;
    @FXML
    MenuItem offres;
    @FXML
    MenuItem messagerie;
    @FXML
    Button modifier;
    @FXML
    Menu florains;
    @FXML
    Button reprise;

    private App app;
    private User user;
    
    public PauseCompteController(User user,App app){
        this.app=app;
        this.user=user;
    }

    public void initialize(){
        username.setText(this.user.getUsername());
        email.setText(this.user.getEmail());
        password.setText(this.user.getPassword());
        phoneNumber.setText(this.user.getPhoneNumber());
        tdb.setOnAction(event->this.app.tdb(this.user));
        quitter.setOnAction(event-> Platform.exit());
        deco.setOnAction(evetn->this.app.accueil());
        infoflo.setOnAction(event-> this.app.infoflorains(this.user));
        offres.setOnAction(event->this.app.listoffres(this.user));
        messagerie.setOnAction(event-> this.app.messagerie(this.user));
        modifier.setOnAction(event-> this.app.modifinfo(this.user));
        florains.setText(this.user.getFlorains() +" florains");
        reprise.setOnAction(event-> this.app.restaurecompte(this.user));
    }


    public void PauseCompte(String username) {
        // Enlève les posts de l'utilisateur de la liste des posts disponibles
            Post p=DatabaseManager.getPostbyUser(username);
            p.setAvailabilityToZero();

            Alert alert = new Alert(Alert.AlertType.CONFIRMATION);
            alert.setTitle("Confirmation");
            alert.setHeaderText("Confirmation de pause du compte");
            alert.setContentText("Votre compte a bien été mis en pause. Vos annonces ne sont donc plus disponibles pour les autres utilisateurs ");
            alert.show();

            
    }
    public void RestoreCompte(String username){
        // Recupère les posts de l'utilisateurs qui ont été enlevés de la base de données
            Post p=DatabaseManager.getPostbyUser(username);
            p.setAvailabilityToOne();
            
            Alert alert = new Alert(Alert.AlertType.CONFIRMATION);
            alert.setTitle("Confirmation");
            alert.setHeaderText("Confirmation de restauration du compte");
            alert.setContentText("Votre compte a bien été restauré. Vos annonces sont de nouveau disponibles pour les autres utilisateurs.");
            alert.show();
        
    }
}
