package telecomnancy.directdealing.controller;

import java.util.List;

import javafx.application.Platform;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.ListView;
import javafx.scene.control.Menu;
import javafx.scene.control.MenuItem;
import telecomnancy.directdealing.App;
import telecomnancy.directdealing.database.DatabaseManager;
import telecomnancy.directdealing.model.Post;
import telecomnancy.directdealing.model.User;

public class TdbController {
    User user;
    @FXML
    Button ajouter;
    @FXML
    Button voiroffres;
    @FXML 
    MenuItem deco;
    @FXML
    MenuItem infoflo;
    @FXML
    MenuItem quitter;
    @FXML
    MenuItem profil;
    @FXML
    MenuItem messagerie;
    @FXML
    Menu florains;
    @FXML
    ListView<String> offres;
    private App app;

    public TdbController(User user,App app){
        this.user=user;
        this.app=app;
    }

    public void initialize(){
        ajouter.setOnAction(event-> this.app.ajouteroffre(this.user));
        voiroffres.setOnAction(event->this.app.listoffres(this.user));

        deco.setOnAction(event-> this.app.accueil());
        infoflo.setOnAction(event-> this.app.infoflorains(this.user));
        quitter.setOnAction(event->Platform.exit());
        profil.setOnAction(event->this.app.profil(this.user));
        messagerie.setOnAction(event-> this.app.messagerie(this.user));
        florains.setText(this.user.getFlorains() +" florains");

        List<String> stringList = DatabaseManager.MyPosts(user);
        ObservableList<String> items = FXCollections.observableArrayList(stringList);
        offres.setItems(items);
        offres.setOnMouseClicked(event -> {
            String selectedItem = offres.getSelectionModel().getSelectedItem();
            if (selectedItem != null){
                int selectedIndex = offres.getSelectionModel().getSelectedIndex()-1;

                String[] parts = selectedItem.split("\\|");
                String info1 = parts[0].trim();
                Post offre=DatabaseManager.getPostbyTitle(info1);
                this.app.modifoffre(this.user, offre);
            }
        });

    }

}
