package telecomnancy.directdealing.database;

import java.io.File;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.time.Duration;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.time.ZoneId;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import javafx.util.Pair;
import lombok.Getter;
import telecomnancy.directdealing.controller.FlorainsController;
import telecomnancy.directdealing.controller.MessagerieController;
import lombok.Setter;
import telecomnancy.directdealing.model.Category;
import telecomnancy.directdealing.model.Post;
import telecomnancy.directdealing.model.PostType;
import telecomnancy.directdealing.model.User;

public class DatabaseManager {
    private static String path = "src/main/resources/DirectDealing.sqlite";
    @Getter
    private static String dbPath = "jdbc:sqlite:" + path;
    @Getter
    @Setter
    private static int n;
    public static List<Post> posts;
    public static List<User> users; 

    private DatabaseManager() {
 

        // createDatabase();
        // createNewTable();
    }

    public static void deleteDatabase() {
        File databaseFile = new File(path);
        databaseFile.delete();
    }

    public static void intialize() {
        createDatabase();
        createUsersTable();
        createPostTable();
        createDemandQueueTable();
        createMessagerieTable();
               // Exemple 1
        User user1 = new User("Alice123", "alice@email.com", "MotDePasse123", "+123456789");

        // Exemple 2
        User user2 = new User("Bob456", "bob@email.com", "Secret456", "+987654321");

        // Exemple 3
        User user3 = new User("Charlie789", "charlie@email.com", "MotDePasse789", "+1122334455");

        // Exemple 4
        User user4 = new User("DavidSmith", "david@email.com", "DavidPass123", "+9988776655");

        // Exemple 5
        User user5 = new User("EvaJohnson", "eva@email.com", "EvaPassword", "+1122334455");

        // Exemple 6
        User user6 = new User("FrankMiller", "frank@email.com", "Frank123", "+1122334455");

        // Exemple 7
        User user7 = new User("GraceTaylor", "grace@email.com", "GracePass", "+1122334455");

        // Exemple 8
        User user8 = new User("HenryBrown", "henry@email.com", "Henry123", "+1122334455");

        // Exemple 9
        User user9 = new User("IsabelClark", "isabel@email.com", "IsabelPass", "+1122334455");

        // Exemple 10
        User user10 = new User("JackieLee", "jackie@email.com", "JackiePassword", "+1122334455");

        users = List.of(user1, user2, user3, user4, user5, user6, user7, user8, user9, user10);

        // Exemple 1 : Cuisine
        Post cuisineAnnonce = new Post(1, user1, "Prêt de Robot de cuisine multifonction",
                "Je prête mon robot culinaire pour une utilisation occasionnelle.",
                "Une fois par semaine", PostType.EQUIPMENT, 0, 0,
                "10/03/2024", "", true, "Lille", Category.CUISINE.toString());

        // Exemple 2 : Informatique
        Post infoAnnonce = new Post(2, user2, "Aide à la configuration d'ordinateur",
                "Je propose mes services pour vous aider à configurer votre ordinateur.",
                "À la demande", PostType.SERVICE, 30, 0,
                "", "", true, "Paris", Category.INFORMATIQUE.toString());

        // Exemple 3 : Scolaire
        Post scolaireAnnonce = new Post(3, user3, "Tutorat en mathématiques",
                "Étudiant en mathématiques propose des séances de tutorat pour lycéens.",
                "Deux fois par mois", PostType.SERVICE, 20, 0,
                "", "", true, "Toulouse", Category.SCOLAIRE.toString());

        // Exemple 4 : Jardinerie
        Post jardinAnnonce = new Post(4, user4, "Service d'entretien de jardin",
                "Je propose mes services pour entretenir votre jardin à la saison.",
                "À la saison", PostType.SERVICE, 50, 0,
                "", "", true, "Nice", Category.JARDINERIE.toString());

        // Exemple 5 : Maison
        Post maisonAnnonce = new Post(5, user5, "Prêt de tondeuse à gazon",
                "Je prête ma tondeuse à gazon pour une utilisation ponctuelle.",
                "Une fois par semaine", PostType.EQUIPMENT, 0, 0,
                "25/02/2024", "", true, "Marseille", Category.MAISON.toString());

        // Exemple 6 : Bricolage
        Post bricolageAnnonce = new Post(6, user6, "Aide au bricolage",
                "Besoin d'aide pour un projet de bricolage ? Je suis là pour vous assister.",
                "À la demande", PostType.SERVICE, 25, 0,
                "", "", true, "Bordeaux", Category.BRICOLAGE.toString());

        // Exemple 7 : Automobile
        Post autoAnnonce = new Post(7, user7, "Prêt de voiture électrique",
                "Je prête ma voiture électrique pour des trajets ponctuels.",
                "À la semaine", PostType.EQUIPMENT, 0, 0,
                "01/04/2024", "", true, "Strasbourg", Category.AUTOMOBILE.toString());

        // Exemple 8 : Bien-être
        Post bienEtreAnnonce = new Post(8, user8, "Séance de méditation guidée",
                "Je propose des séances de méditation guidée pour favoriser le bien-être.",
                "Une fois par semaine", PostType.SERVICE, 15, 0,
                "", "", true, "Lyon", Category.BIEN_ETRE.toString());

        // Exemple 9 : Mode
        Post modeAnnonce = new Post(9, user9, "Prêt de vêtements de soirée",
                "Je prête mes vêtements de soirée pour une occasion spéciale.",
                "À la demande", PostType.EQUIPMENT, 0, 0,
                "", "", true, "Paris", Category.MODE.toString());

        // Exemple 10 : Loisirs
        Post loisirsAnnonce = new Post(10, user10, "Service de guide touristique",
                "Je propose mes services en tant que guide touristique local.",
                "À la demande", PostType.SERVICE, 40, 0,
                "", "", true, "Grenoble", Category.LOISIRS.toString());

        posts = List.of(
                cuisineAnnonce,
                infoAnnonce,
                scolaireAnnonce,
                jardinAnnonce,
                maisonAnnonce,
                bricolageAnnonce,
                autoAnnonce,
                bienEtreAnnonce,
                modeAnnonce,
                loisirsAnnonce);
    }

    public static void createDatabase() {
        File f = new File(path);
        if (f.exists()) {
            System.out.println("The database already exists.");
            return;
        }
        try (Connection connection = DriverManager.getConnection(dbPath)) {
            if (connection != null) {
                DatabaseMetaData meta = connection.getMetaData();
                System.out.println("The driver name is " + meta.getDriverName());
                System.out.println("A new database has been created.");
                connection.close();
                n = 1;
            }

        } catch (SQLException e) {
            System.out.println(e.getMessage());
        }
    }

    public static void createUsersTable() {
        // SQLite connection string

        // SQL statement for creating a new table
        String sql = "CREATE TABLE IF NOT EXISTS users (\n"
                + "username VARCHAR(255) PRIMARY KEY, "
                + "email VARCHAR(255), "
                + "password VARCHAR(255), "
                + "phoneNumber VARCHAR(20), "
                + "florains INTEGER DEFAULT 1000, "
                + "timeBeforeNextPause INTEGER);";

        try (Connection connection = DriverManager.getConnection(dbPath);
                Statement stmt = connection.createStatement()) {
            // create a new table
            stmt.execute(sql);
            connection.close();
        } catch (SQLException e) {
            System.out.println(e.getMessage());
        }
    }

    public static User getUserByUsername(String username) {
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            PreparedStatement preparedStatement = connection.prepareStatement(
                    "SELECT * FROM users WHERE username = ?;");
            preparedStatement.setString(1, username);
            ResultSet result = preparedStatement.executeQuery();
            result.next();
            String email = result.getString("email");

            String password = result.getString("password");
            String phoneNumber = result.getString("phoneNumber");
            int florains = result.getInt("florains");
            int pause = result.getInt("timeBeforeNextPause");
            connection.close();
            User user = new User(
                    username,
                    email,
                    password,
                    phoneNumber);

            user.setFlorains(florains);

            user.setTimeBeforeNextPause(pause);
            // TODO: recuperer les post achetés et mis en vente
            return user;
        } catch (Exception e) {
            e.printStackTrace();

            return null;
        }

    }

    public static boolean userExists(String username) {
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            PreparedStatement preparedStatement = connection.prepareStatement(
                    "SELECT * FROM users WHERE username = ?;");
            preparedStatement.setString(1, username);
            ResultSet result = preparedStatement.executeQuery();
            boolean b = result.next();
            connection.close();
            return b;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

    public static boolean userExists(User user) {
        return userExists(user.getUsername());
    }

    public static CredentialsCheck checkCredentials(String username, String password) {
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            PreparedStatement preparedStatement = connection.prepareStatement(
                    "SELECT * FROM users WHERE username = ?;");
            preparedStatement.setString(1, username);
            ResultSet result = preparedStatement.executeQuery();
            if (result.next()) {
                if (result.getString("password").equals(password)) {
                    connection.close();
                    return CredentialsCheck.CONNECTED;
                } else {
                    connection.close();
                    return CredentialsCheck.WRONG_PASSWORD;
                }
            } else {
                connection.close();
                return CredentialsCheck.WRONG_USERNAME;
            }
        } catch (SQLException exception) {
            exception.printStackTrace();
            return null;
        }
    }

    // ------------------------ GESTION DES UTILISATEURS ---------------------------

    public static void deleteUsersTable() {
        // SQLite connection string

        // SQL statement for creating a new table
        String sql = "DROP TABLE IF EXISTS users;";

        try (Connection connection = DriverManager.getConnection(dbPath);
                Statement stmt = connection.createStatement()) {
            // create a new table
            stmt.execute(sql);
            connection.close();
        } catch (SQLException e) {
            System.out.println(e.getMessage());
        }
    }

    public static void addUser(User user) {
        if (userExists(user)) {
            System.err.println("L'utilisateur existe déja.");
            return;
        }
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            PreparedStatement preparedStatement = connection
                    .prepareStatement(
                            "INSERT INTO users (username, email,password,phoneNumber,florains) VALUES (?, ?, ?, ?, ?)");
            preparedStatement.setString(1, user.getUsername());
            preparedStatement.setString(2, user.getEmail());
            preparedStatement.setString(3, user.getPassword());
            preparedStatement.setString(4, user.getPhoneNumber());
            preparedStatement.setInt(5, user.getFlorains());
            preparedStatement.executeUpdate();
            connection.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Could not add user.");
        }
    }

    public static void deleteUser(String username) {
        if (!userExists(username)) {
            System.err.println("L'utilisateur n'existe pas.");
            return;
        }
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            PreparedStatement preparedStatement = connection
                    .prepareStatement("DELETE FROM users WHERE username LIKE ?;");
            preparedStatement.setString(1, username);
            preparedStatement.executeUpdate();
            connection.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void deleteUser(User user) {
        deleteUser(user.getUsername());
    }

    // ------------------------ GESTION DES FLORAINS ---------------------------
    public static int getUserFlorains(String username) {
        try (Connection connection = DriverManager.getConnection(dbPath)) {
            PreparedStatement preparedStatement = connection
                    .prepareStatement("SELECT florains FROM users WHERE username = ?");
            preparedStatement.setString(1, username);
            ResultSet resultSet = preparedStatement.executeQuery();
            resultSet.next();
            int amount = resultSet.getInt("florains");
            connection.close();
            return amount;
        } catch (SQLException e) {
            // Gérer l'exception ici (imprimer un message, enregistrer des journaux, etc.)
            e.printStackTrace();
            return -1;
        }
    }

    public static int getUserFlorains(User user) {
        return getUserFlorains(user.getUsername());
    }

    public static void setUserFlorains(String username, int amount) {
        try (Connection connection = DriverManager.getConnection(dbPath)) {
            PreparedStatement preparedStatement = connection
                    .prepareStatement("UPDATE users SET florains = ? WHERE username = ?");
            preparedStatement.setInt(1, amount);
            preparedStatement.setString(2, username);
            preparedStatement.executeUpdate();
            connection.close();
        } catch (SQLException e) {
            // Gérer l'exception ici (imprimer un message, enregistrer des journaux, etc.)
            e.printStackTrace();
        }
    }

    public static void setUserFlorains(User user, int amount) {
        setUserFlorains(user.getUsername(), amount);
    }

    public static void updateUserFlorains(User user) {
        setUserFlorains(user.getUsername(), user.getFlorains());
    }

    public static void addFlorains(String username, int amount) {
        int current = getUserFlorains(username);
        setUserFlorains(username, current + amount);
    }

    public static void subFlorains(String username, int amount) {
        int current = getUserFlorains(username);
        setUserFlorains(username, current - amount);
    }

    // ------------------------ GESTION DES OFFRES ---------------------------
    public static boolean postExists(int postId) {
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            PreparedStatement preparedStatement = connection.prepareStatement(
                    "SELECT * FROM Posts WHERE postId = ?;");
            preparedStatement.setInt(1, postId);
            ResultSet result = preparedStatement.executeQuery();
            boolean b = result.next();
            connection.close();
            return b;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

    public static void addPost(Post post) {
        if (postExists(post.getId())) {
            System.err.println("L'offre existe déja.");
        }
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            PreparedStatement preparedStatement = connection
                    .prepareStatement(
                            "INSERT INTO Posts ( " +
                                    "postId, " +
                                    "ownerId, " +
                                    "title, " +
                                    "description, " +
                                    "frequency, " +
                                    "type, " +
                                    "price, " +
                                    "duration, " +
                                    "startDate, " +
                                    "endDate, " +
                                    "available, " +
                                    "location, " +
                                    "categoryId)" +
                                    "VALUES (?, ?, ?, ?,?, ?, ?, ?, ?, ?, ?, ?,?);");
            preparedStatement.setInt(1, post.getId());
            preparedStatement.setString(2, post.getOwner().getUsername());
            preparedStatement.setString(3, post.getTitle());
            preparedStatement.setString(4, post.getDescription());
            preparedStatement.setString(5, post.getFrequency());
            preparedStatement.setString(6, post.getType().toString());
            preparedStatement.setInt(7, post.getPrice());
            preparedStatement.setLong(8, post.getDuration());
            preparedStatement.setString(9, post.getStartDate());
            preparedStatement.setString(10, post.getEndDate());
            preparedStatement.setBoolean(11, post.isAvailable());
            preparedStatement.setString(12, post.getLocation());
            preparedStatement.setString(13, post.getCategory());
            preparedStatement.executeUpdate();
            n++;
            connection.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Could not add post.");
        }
    }

    public static void createPostTable() {
        // SQLite connection string

        // SQL statement for creating a new table
        String sql = "CREATE TABLE IF NOT EXISTS Posts ("
                + "postId INTEGER PRIMARY KEY, "
                + "ownerId TEXT, "
                + "title VARCHAR(255), "
                + "description VARCHAR(255),"
                + "frequency VARCHAR(255), "
                + "type VARCHAR(255), "
                + "price INTEGER, "
                + "duration BIGINT, "
                + "startDate VARCHAR(255), "
                + "endDate VARCHAR(255), "
                + "available BOOLEAN, "
                + "location VARCHAR(255), "
                + "categoryId VARCHAR(255), "
                + "pause BIGINT, "
                + "FOREIGN KEY (ownerId) REFERENCES User(userId)); ";

        try (Connection connection = DriverManager.getConnection(dbPath);
                Statement stmt = connection.createStatement()) {
            // create a new table
            stmt.execute(sql);
            connection.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public static void deletePost(int postId) {
        if (postExists(postId)) {
            System.err.println("L'offre existe déja.");
        }

        try {
            Connection connection = DriverManager.getConnection(dbPath);
            PreparedStatement preparedStatement = connection
                    .prepareStatement("DELETE FROM Posts WHERE postId = ?;");
            preparedStatement.setInt(1, postId);
            preparedStatement.executeUpdate();
            connection.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void deletePost(Post post) {
        deletePost(post.getId());
    }

    public static Pair<List<String>, List<String>> getAllPosts() {
        List<String> Posts = new ArrayList<>();
        Posts.add("Titre | Fréquence | Prix | Date de début | Date de fin | Localisation | Catégorie");
        List<String> idposts = new ArrayList<>();

        String currentPost;
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            String query = "SELECT * FROM Posts";
            PreparedStatement preparedStatement = connection.prepareStatement(query);
            ResultSet resultSet = preparedStatement.executeQuery();

            while (resultSet.next()) {
                if (resultSet.getBoolean("available")) {
                    idposts.add(resultSet.getString("postId"));
                    currentPost = resultSet.getString("title") + " | " + resultSet.getString("frequency") + " | "
                            + resultSet.getString("price") + " | " + resultSet.getString("startDate") + " | "
                            + resultSet.getString("endDate") + " | " + resultSet.getString("location") + " | "
                            + resultSet.getString("categoryId");
                    Posts.add(currentPost);
                }
            }
            connection.close();
            return new Pair<>(Posts, idposts);
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Could not find any post.");
            return new Pair<>(Posts, idposts);
        }
    }

    public static String StringDate2String(String date) {
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("dd-MM-yyyy");
        long timestamp = Long.parseLong(date);
        Instant instant = Instant.ofEpochMilli(timestamp);
        LocalDateTime localdate = LocalDateTime.ofInstant(instant, ZoneId.of("UTC"));
        return localdate.format(formatter);
    }

    public static Post getPostbyId(int idpost) {
        PostType type;
        String frequence;
        long duration;
        User owner;
        String startDate;
        String endDate;

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            String query = "SELECT * FROM Posts WHERE postId = ?";
            PreparedStatement preparedStatement = connection.prepareStatement(query);
            preparedStatement.setInt(1, idpost); // Utilisez setInt pour un identifiant d'entier
            ResultSet resultSet = preparedStatement.executeQuery();

            if (resultSet.next()) { // Vérifier s'il y a des résultats
                if (resultSet.getString("frequency").equalsIgnoreCase("ponctuel")) {
                    frequence = "ponctuel";
                } else {
                    frequence = "recurrent";
                }

                if (resultSet.getString("type").equalsIgnoreCase("service")) {
                    type = PostType.SERVICE;
                } else {
                    type = PostType.EQUIPMENT;
                }

                duration = resultSet.getLong("duration");
                // ICI
                String ownerID = resultSet.getString("ownerId");
                startDate = resultSet.getString("startDate");
                endDate = resultSet.getString("endDate");
                int postId = resultSet.getInt("postId");
                String description = resultSet.getString("description");
                String location = resultSet.getString("location");
                String category = resultSet.getString("categoryId");
                String title = resultSet.getString("title");

                connection.close();
                owner = DatabaseManager.getUserByUsername(ownerID);
                return new Post(
                        postId,
                        owner,
                        title,
                        description,
                        frequence,
                        type,
                        50,
                        duration,
                        startDate,
                        endDate,
                        true,
                        location,
                        category);

            } else {
                // Aucun résultat trouvé
                System.err.println("Aucun post trouvé.");
                connection.close();
                return new Post();
            }

        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Erreur lors de la recherche du post." + idpost);
            return new Post();
        }
    }

    public static Post getPostbyUser(String username) {
        PostType type;
        String frequence;
        long duration;
        User owner;
        String startDate;
        String endDate;

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            String query = "SELECT * FROM Posts WHERE ownerId = ?";
            PreparedStatement preparedStatement = connection.prepareStatement(query);
            preparedStatement.setString(1, username);
            ResultSet resultSet = preparedStatement.executeQuery();

            if (resultSet.next()) { // Vérifier s'il y a des résultats
                if (resultSet.getString("frequency").equalsIgnoreCase("ponctuel")) {
                    frequence = "ponctuel";
                } else {
                    frequence = "recurrent";
                }

                if (resultSet.getString("type").equalsIgnoreCase("service")) {
                    type = PostType.SERVICE;
                } else {
                    type = PostType.EQUIPMENT;
                }

                duration = resultSet.getLong("duration");
                // ICI
                String ownerID = resultSet.getString("ownerId");
                startDate = resultSet.getString("startDate");
                endDate = resultSet.getString("endDate");
                int postId = resultSet.getInt("postId");
                String description = resultSet.getString("description");
                String location = resultSet.getString("location");
                String category = resultSet.getString("categoryId");
                String title = resultSet.getString("title");

                connection.close();
                owner = DatabaseManager.getUserByUsername(ownerID);
                return new Post(
                        postId,
                        owner,
                        description,
                        title,
                        frequence,
                        type,
                        50,
                        duration,
                        startDate,
                        endDate,
                        true,
                        location,
                        category);

            } else {
                // Aucun résultat trouvé
                System.err.println("Aucun post trouvé.");
                connection.close();
                return new Post();
            }

        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Erreur lors de la recherche du post." + username);
            return new Post();
        }
    }

    public static Post getPostbyTitle(String title) {
        PostType type;
        String frequence;
        long duration;
        User owner;
        String startDate;
        String endDate;
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            String sql = "SELECT * FROM Posts WHERE title = ?";
            try (PreparedStatement statement = connection.prepareStatement(sql)) {
                statement.setString(1, title);

                try (ResultSet resultSet = statement.executeQuery()) {
                    if (resultSet.next()) {
                        if (resultSet.getString("frequency").equalsIgnoreCase("ponctuel")) {
                            frequence = "ponctuel";
                        } else {
                            frequence = "recurrent";
                        }

                        if (resultSet.getString("type").equalsIgnoreCase("service")) {
                            type = PostType.SERVICE;
                        } else {
                            type = PostType.EQUIPMENT;
                        }

                        duration = resultSet.getLong("duration");
                        // ICI
                        String ownerID = resultSet.getString("ownerId");
                        startDate = resultSet.getString("startDate");
                        endDate = resultSet.getString("endDate");
                        int postId = resultSet.getInt("postId");
                        String description = resultSet.getString("description");
                        String location = resultSet.getString("location");
                        String category = resultSet.getString("categoryId");

                        connection.close();
                        owner = DatabaseManager.getUserByUsername(ownerID);
                        return new Post(
                                postId,
                                owner,
                                title,
                                description,
                                frequence,
                                type,
                                50,
                                duration,
                                startDate,
                                endDate,
                                true,
                                location,
                                category);

                    } else {
                        // Aucun résultat trouvé
                        System.err.println("Aucun post trouvé.");
                        connection.close();
                        return new Post();
                    }
                }
            }

        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Erreur lors de la recherche du post :" + title);
            return new Post();
        }
    }

    public static List<String> MyPosts(User user) {
        List<String> Posts = new ArrayList<>();
        Posts.add("Titre | Fréquence | Prix | Date de début | Date de fin | Localisation | Catégorie");

        String currentPost;
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            PreparedStatement preparedStatement = connection.prepareStatement(
                    "SELECT * FROM Posts WHERE ownerId=?;");
            preparedStatement.setString(1, user.getUsername());
            ResultSet resultSet = preparedStatement.executeQuery();
            while (resultSet.next()) {
                if (resultSet.getBoolean("available")) {
                    currentPost = resultSet.getString("title") + " | " + resultSet.getString("frequency") + " | "
                            + resultSet.getString("price") + " | " + resultSet.getString("startDate") + " | "
                            + resultSet.getString("endDate") + " | " + resultSet.getString("location") + " | "
                            + resultSet.getString("categoryId");
                    Posts.add(currentPost);
                }
            }
            connection.close();
            return Posts;
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Could not dislpay posts.");
            return Posts;
        }
    }

    public static void createDemandQueueTable() {
        String createTableSQL = "CREATE TABLE IF NOT EXISTS DemandQueues ("
                + "postId INTEGER, "
                + "userId INTEGER, "
                + "rank INTEGER,"
                + "FOREIGN KEY (postId) REFERENCES Post(postId), "
                + "FOREIGN KEY (userId) REFERENCES User(userId));";

        try (Connection connection = DriverManager.getConnection(dbPath);
                Statement statement = connection.createStatement()) {
            // Execute the SQL statement to create the table
            statement.execute(createTableSQL);
            connection.close();
            // System.out.println("Table 'DemandQueue' created successfully.");

        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public static void modif(Post offre) {
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            String sql = "UPDATE Posts SET title = ?, description = ?, startDate = ?, endDate = ?, location = ? WHERE postid = ?";
            try (PreparedStatement statement = connection.prepareStatement(sql)) {
                statement.setString(1, offre.getTitle());
                statement.setString(2, offre.getDescription());
                statement.setString(3, offre.getStartDate());
                statement.setString(4, offre.getEndDate());
                statement.setString(5, offre.getLocation());
                statement.setLong(6, offre.getId());

                statement.executeUpdate();
            }
        } catch (SQLException e) {
            // TODO: handle exception
            e.printStackTrace();
            System.err.println("Could not modify post.");
        }
    }

    public static List<Post> getDbPosts() {
        List<Integer> listPostId = new LinkedList<>();
        List<Post> listPosts = new LinkedList<>();
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            String query = "SELECT * FROM Posts;";
            Statement statement = connection.createStatement();
            ResultSet resultSet = statement.executeQuery(query);
            while (resultSet.next()) {
                if (resultSet.getBoolean("available")) {

                    listPostId.add(resultSet.getInt("postId"));
                }
            }
            connection.close();
            for (int i = 0; i < listPostId.size(); i++) {
                listPosts.add(extractPost(listPostId.get(i)));
            }
            return listPosts;
        } catch (Exception e) {
            System.err.println("COULD NOT GET POSTS FROM DATABASE.");
            e.printStackTrace();
            return null;
        }
    }

    public static List<Post> getDbPostsByCategory(Category category) {
        List<Integer> listPostId = new LinkedList<>();
        List<Post> listPosts = new LinkedList<>();
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            String query = String.format("SELECT postId FROM Posts WHERE LOWER(categoryId) LIKE LOWER('%s');",
                    category.toString());
            Statement statement = connection.createStatement();
            ResultSet resultSet = statement.executeQuery(query);
            while (resultSet.next()) {
                listPostId.add(resultSet.getInt("postId"));
            }
            connection.close();
            for (int i = 0; i < listPostId.size(); i++) {
                listPosts.add(extractPost(listPostId.get(i)));
            }
            return listPosts;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static Post extractPost(int postId) {
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            String query = "SELECT * FROM Posts WHERE postId = ?;";
            PreparedStatement statement = connection.prepareStatement(query);
            statement.setInt(1, postId);
            ResultSet resultSet = statement.executeQuery();
            resultSet.next();
            String ownerId = resultSet.getString("ownerId");
            String title = resultSet.getString("title");
            String frequency = resultSet.getString("frequency");
            String type = resultSet.getString("type");
            int price = resultSet.getInt("price");
            long duration = resultSet.getLong("duration");
            String startDate = resultSet.getString("startDate");
            String endDate = resultSet.getString("endDate");
            boolean available = resultSet.getBoolean("available");
            String location = resultSet.getString("location");
            String category = resultSet.getString("categoryId");
            Long pause = resultSet.getLong("pause");
            connection.close();
            Post post = new Post(postId, getUserByUsername(ownerId), title, type, frequency, PostType.valueOf(type),
                    price, duration, startDate, endDate, available, location, category);
            Duration pauseDuration = Duration.ofMillis(pause);
            post.setPause(pauseDuration);
            return post;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static void acceptPost(User owner, String buyer, int idPost) {
        try {
            Connection connection = DriverManager.getConnection(dbPath);
            String sql = "UPDATE Posts SET available = ? WHERE postid = ?";
            try (PreparedStatement statement = connection.prepareStatement(sql)) {
                statement.setBoolean(1, false);
                statement.setInt(2, idPost);
                statement.executeUpdate();
                connection.close();
                FlorainsController.transfertFlorains(owner.getUsername(), buyer, 50);
                MessagerieController.addMessage(owner.getUsername(), buyer, "J'accepte !");
            }
        } catch (SQLException e) {
            // TODO: handle exception
            e.printStackTrace();
            System.err.println("Could not accept post.");
        }
    }

    // ---------------Messagerie----------------

    public static void createMessagerieTable() {
        // SQLite connection string

        // SQL statement for creating a new table
        String sql = "CREATE TABLE IF NOT EXISTS messagerie (\n"
                + "	idmsg text PRIMARY KEY,\n"
                + "	idconv text,\n"
                + "	usernameFROM text,\n"
                + "	usernameTO text,\n"
                + "	message text,\n"
                + "	time bigint\n"
                + ");";

        try (Connection conn = DriverManager.getConnection(dbPath);
                Statement stmt = conn.createStatement()) {
            stmt.execute(sql);
            conn.close();
        } catch (SQLException e) {
            System.out.println(e.getMessage());
        }
    }
}
