package telecomnancy.directdealing.model;

import java.time.Duration;
import java.time.LocalDateTime;
import java.util.LinkedList;
import java.util.Queue;

import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class Post {
    private int id;
    private User owner;
    private User buyer;
    private String title;
    private String frequency;
    private String description;
    private PostType type;
    private int price;
    private long duration;
    private String startDate;
    private String endDate;
    private boolean available;
    private String location;
    private String category;
    private Queue<User> demandQueue;
    private Duration pause;

    public Post() {
    };

    public Post(int id,
            User owner,
            String title,
            String description,
            String frequency,
            PostType type,
            int price,
            long duration,
            String startDate,
            String endDate,
            boolean available,
            String location,
            String category) {
        this.id = id;
        this.owner = owner;
        this.title = title;
        this.description = description;
        this.frequency = frequency;
        this.type = type;
        this.price = price;
        this.duration = duration;
        this.startDate = startDate;
        this.endDate = endDate;
        this.available = available;
        this.location = location;
        this.category = category;
        this.demandQueue = new LinkedList<>();
    }

    public void setAvailabilityToOne(){
        this.available=true;
    }
    public void setAvailabilityToZero(){
        this.available=false;
    }
    @Override
    public String toString() {
        return this.title + " | " +
                this.frequency + " | " +
                this.price + " | " +
                this.startDate + " | " +
                this.endDate + " | " +
                this.location + " | ";
    }
}
