package telecomnancy.directdealing.model;

import java.util.List;

import lombok.Getter;
import lombok.Setter;
import telecomnancy.directdealing.database.DatabaseManager;

@Setter
@Getter
public class User {
    private String username;
    private String email;
    private String password;
    private String phoneNumber;
    private int florains = 1000;
    private List<Post> currentPostsSold;
    private List<Post> currentPostsBought;
    private List<Post> offres;
    private int timeBeforeNextPause;

    public User() {
    }

    public User(String username, String email, String password, String phoneNumber) {
        this.username = username;
        this.email = email;
        this.password = password;
        this.phoneNumber = phoneNumber;
    }

    public void setFlorains(int amount) {
        this.florains = amount;
        DatabaseManager.setUserFlorains(this, this.getFlorains());
    }

    public void addFlorains(int amount) {
        this.florains += amount;
        DatabaseManager.setUserFlorains(this, this.getFlorains());
    }

    public void subFlorains(int amount) {
        this.florains -= amount;
        DatabaseManager.setUserFlorains(this, this.getFlorains());
    }
}
