package telecomnancy.directdealing.controller;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import java.util.List;

import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Test;

import telecomnancy.directdealing.database.DatabaseManager;
import telecomnancy.directdealing.model.User;

public class MessagerieControllerTest {
    @Order(1)
    @Test
    public void createNewTableTest() {
        DatabaseManager.createMessagerieTable();
        String sql = "SELECT name \n" +
                     "FROM sqlite_master \n" +
                     "WHERE type = 'table' AND name = 'messagerie'";
        try {
            Connection connection = DriverManager.getConnection(MessagerieController.getDbPath());
            Statement stmt = connection.createStatement();
            ResultSet result = stmt.executeQuery(sql);
    
            assertTrue(result.next());
            assertEquals("messagerie", result.getString("name"));
            connection.close();
        } catch (SQLException e) {
            assertTrue(false);
            e.printStackTrace();
        }
    }
    

    @Order(2)
    @Test
    public void addMessageTest() {
        // DatabaseManager.deleteUser("test_user");
        String username = "ilyes";
        
        User testUser = new User(username, "null", "null", "null");
        DatabaseManager.addUser(testUser);
        String message = "blablabla";
        MessagerieController.addMessage(testUser.getUsername(), testUser.getUsername(), message);
        String sql = "SELECT message \n" +
                      "FROM messagerie \n" +
                    "WHERE usernameFROM = '"+ username + "';";
        try {
            Connection connection = DriverManager.getConnection(MessagerieController.getDbPath());
            Statement stmt = connection.createStatement();  
            stmt.execute(sql);

            ResultSet result = stmt.getResultSet();
            assertTrue(result.next());
            // assertEquals(message, result.getString("message"));
            connection.close();
            DatabaseManager.deleteUser(username);
        } catch (SQLException e) {
            DatabaseManager.deleteUser(username);
            e.printStackTrace();
            assertTrue(false);
        }

    }

    @Order(3)
    @Test
    public void messagesWithTest() {
        String username = "ilyes";
        
        User testUser = new User(username, "null", "null", "null");
        DatabaseManager.addUser(testUser);
        String testMsg = "testBlabla";
        MessagerieController.addMessage(testUser.getUsername(), testUser.getUsername(), testMsg);
        List<String> testmessages= MessagerieController.messagesWith(testUser.getUsername(), testUser.getUsername());
        assertEquals(testMsg, testmessages.get(1));

    }

    @Order(4)
    @Test
    public void getContactsOfTest() {
        String username = "test_user";
        
        User testUser = new User(username, "null", "null", "null");
        DatabaseManager.addUser(testUser);
        String testMsg = "testBlabla";
        MessagerieController.addMessage(testUser.getUsername(), testUser.getUsername(), testMsg);
        List<String> testcontact = MessagerieController.getContactsOf(testUser);
        assertEquals(username, testcontact.get(0));
    }

    @Order(5)
    @Test
    public void deleteMessagerieTableTest() {
        MessagerieController.deleteMessagerieTable();
    }
}
